# Creation of MySQL Tables for simple_test of PISD

# htmlindex is the service list for a realm. A realm gathers and updates
# its services to this table.
# The script 'p.pl', which gathers the services, gathers the author and
# keywords info. But, in simple_test, author field and keywords field are
# not used for PISD.
CREATE TABLE IF NOT EXISTS htmlindex
(
    serviceId       VARCHAR(128) primary key,
    title           VARCHAR(255), # if NULL, invalid service 
    accessMethod    VARCHAR(255),
    author          VARCHAR(255) DEFAULT NULL,
    keywords        VARCHAR(255) DEFAULT NULL,
    modifiedTime    TIMESTAMP(12) NOT NULL
);

# serviceindex is the service list for a PISD server. A PISD server
# gathers and update services of realms to this table
CREATE TABLE IF NOT EXISTS serviceindex
(
	host			VARCHAR(128) NOT NULL,
	realm			VARCHAR(128) NOT NULL,
	serviceId       VARCHAR(128) NOT NULL,
    modifiedTime    VARCHAR(20) NOT NULL,
    title           VARCHAR(255), # if NULL, invalid service 
    accessMethod    VARCHAR(255),
#	createdTime		VARCHAR(20) DEFAULT NULL,
#    author          VARCHAR(255) DEFAULT NULL,
#    keywords        VARCHAR(255) DEFAULT NULL,
	PRIMARY KEY ( host, realm, serviceId )
);
