#ifndef REALM_HTMLINDEX_H
#define REALM_HTMLINDEX_H

#include <mysql/mysql.h>
#include "realm.h"

#define MYSQL_CLIENT_HOST   "localhost"
#define MYSQL_CLIENT_DB     "pisd"
#define MYSQL_CLIENT_PASSWD ""
#define MYSQL_CLIENT_TABLE  "htmlindex"
#ifndef MYSQL_CLIENT_USER   
#define MYSQL_CLIENT_USER   "admin"
#endif

/* makes a RealmLog from htmlindex table in MySQL database */
class HtmlindexRealmLog: public RealmLog
{
	public:
		int getFromMysqlResult(MYSQL_RES *result);
};

/* makes Pisd difference response Message from htmlindex table
 * in MySQL database.
 */
class HtmlindexDifferenceResponse
{
	protected:
		int maxSize;
		bool haveMore;
		MYSQL_RES *mysqlResult;
		int numRows;

	public:
		HtmlindexDifferenceResponse(const int ms = 0)
			{ maxSize=ms; mysqlResult=NULL; numRows=0; }
		HtmlindexDifferenceResponse(const char *lastTime, const int ms = 0);
		
		int getMysqlResult(const char *lastTime);
		PisdMessage *toPisdMessage();

		/* accessor */
		bool isValidResponse() { return (numRows > 0); }
		bool isHaveMore() { return haveMore; }
};
#endif
