#ifndef REALM_SERVICEINDEX_H
#define REALM_SERVICEINDEX_H

#include <mysql/mysql.h>
#include "realm.h"
//#include "simple_pisd_asn1.h"

/* makes a RealmLog from serviceindes table in MySQL database */
class ServiceindexRealmLog: public RealmLog
{
	public:
		int getFromMysqlResult(MYSQL_RES *result);
};

/* makes PISD difference response message from serviceindex
 * table in MySQL database 
 */
class ServiceindexDifferenceResponse
{
	protected:
		int maxSize;
		bool haveMore;
		MYSQL_RES *mysqlResult;
		int numRows;

	public:
		ServiceindexDifferenceResponse(int ms = 0)
			{ maxSize=ms; mysqlResult=NULL; }
		
		int getMysqlResult(const char *realm,
				const char *host, const char *lastTime);
		PisdMessage *toPisdMessage();

		/* accessor */
		bool isHaveMore() { return haveMore; }
};
#endif
