#include <stdio.h>
#include "server_mysql.h"

static void octs2str(char *dst, const AsnOcts &octs)
{
	int len = octs.Len();
	char *src = (AsnOcts &) octs;
	memcpy(dst, src, len);
	dst[len]=0;
}

/* class SeverMysql */

ServerMysql::ServerMysql(const char *h, const char *r)
{
	host = h;
	realm = r;
}

ServerMysql::~ServerMysql()
{
	mysql_close(&mysql);
}

int ServerMysql::openMysql()
{
	mysql_init(&mysql);
	if (!mysql_real_connect( &mysql, MYSQL_SERVER_HOST, MYSQL_SERVER_USER,
				MYSQL_SERVER_PASSWD, MYSQL_SERVER_DB, 0, NULL, 0))
	{
		//fprintf(stderr, "Failed to connect to database: Error: %s\n",
		//		mysql_error(mysql));
		return -1;
	}
	return 0;
}

int ServerMysql::updateTable(DifferenceResponse *serviceLogList)
{
	char queryStr[2000];
	ServiceLog *sl;

	serviceLogList->serviceLogs.SetCurrToFirst();
	sl = serviceLogList->serviceLogs.First();
	
	while(sl)
	{
		// update a service
		char serviceId[(int)maxServiceIdSize + 1];
		char modifiedTime[21];
		char title[(int)maxTitleSize + 1];
		char accessMethod[(int)maxUrlSize + 1];

		octs2str(serviceId, sl->serviceId);
		octs2str(modifiedTime, sl->modifiedTime);

		switch (sl->description->choiceId)
		{
			case ServiceLogChoice::invalidServiceCid:
				sprintf(queryStr,
						"REPLACE INTO " MYSQL_SERVER_TABLE 
						" VALUES ('%s', '%s', '%s', '%s', NULL, NULL)",
						host, realm, serviceId, modifiedTime);
				break;
			case ServiceLogChoice::validServiceCid:
				octs2str(title, sl->description->validService->title);
				octs2str(accessMethod, 
						sl->description->validService->accessMethod);
				sprintf(queryStr,
						"REPLACE INTO " MYSQL_SERVER_TABLE 
						" VALUES ('%s', '%s', '%s', '%s', '%s','%s')",
						host, realm, serviceId, modifiedTime, title,
						accessMethod);
				break;
		}
		int ret = mysql_query(&mysql, queryStr);

		if(ret)
		{
			printf("error in %s\n",queryStr);
			return -1;
		}

		sl = serviceLogList->serviceLogs.GoNext();
	}
}
